/*
 * wysmod - ar2clp.c
 * 	version 0.0.0
 *
 * 	AR-2c Logger Protocol (will be compatible with version 4.1)
 * 
 * Copyright (C) 2005, 2006, 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/serial.h>
#include <tmos/jiffies.h>
#include <tmos/port.h>

#include "ar2clp.h"

const __code uint8_t get_id_cmd[7] =
		{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd2 };

char ar2c_resync(char fd)
{
	uint8_t buf[sizeof(get_id_cmd)];
	jiffies_t t;

	t = get_jiffies();
	do {
		if (!port_read_timeout(fd, buf, sizeof(buf), MS_JIFFIES(50)))
			break;
	} while (get_jiffies() - t <= MS_JIFFIES(300));

	do {
		tmos_memcpy(buf, get_id_cmd, sizeof(get_id_cmd));
		port_write(fd, buf, sizeof(get_id_cmd));
		if (port_read_timeout(fd, buf, sizeof(buf), MS_JIFFIES(400)) == 2)
			return 0;
	} while (get_jiffies() - t <= S_JIFFIES(2));
	return 1;
}
