/*
 * tmos - log2.c
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <tmos/kernel.h>
#include <tmos/log2.h>

unsigned char __fls_u8(u8 x)
{
	unsigned char ret = 8;

	if (!x)
		return 0;
	if (!(x & 0xf0)) {
		x <<= 4;
		ret -= 4;
	}
	if (!(x & 0xc0)) {
		x <<= 2;
		ret -= 2;
	}
	if (!(x & 0x80))
		ret--;
	return ret;
}
