/*
 * crc5.h
 *
 * CRC-5 USB little-endian checksum (0x14 polynomial)
 *
 * Copyright (C) 2013  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef __CRC5_H
#define __CRC5_H

#include <tmos/types.h>

extern const u8 crc5_table[256];
extern const u8 crc5_3_table[32];

#define crc5_byte(crc, x) (crc5_table[(crc) ^ (x)])
#define crc5_3(crc, x) (crc5_3_table[(crc) ^ (x)])

u8 crc5(u8 crc, const u8 __kernel *buf, unsigned char len);

#endif
